/**************************************************************************/
/*  gW^RUUSegpedu_arm1p (w6v6bx[Xj                       */
/*  QOPP^OQ^PR쐬Jn                                          */
/**************************************************************************/

//#include <3664F.H> //{̃R[hEEEH8RpCp
#include "3664F.H" //Visual StudioŃG[\oȂ悤ɁAɒuwb_t@CQƍs

/*********************************************************************/
/*֐̃vg^Cv錾*/
void generate_signal(unsigned int servo_data[8]);
void wait_val(unsigned int servo_data[2]);
void init_main(void);

void print_ii_sci3b(unsigned int data);
void print_ii_sci3(unsigned int data);
void print_c_sci3(unsigned char	data);

unsigned char read_c_sci3(void);
unsigned char read_c_sci3_b(void);
unsigned int read_ii_sci3b(void);

unsigned char sio_comm(unsigned int servo_data[8], unsigned char *servo_sw);

/*********************************************************************/
void main(void)
{
unsigned char	command;
unsigned char	servo_sw;
unsigned int	timer;
unsigned int	servo_data[8];		/*qbT[{o̓f[^*/

	/*|[gȂǂ̏*/
	init_main();

	/*VXeX^[g̓T[{nee*/
	servo_sw	= 0;

	/*qbT[{o̓f[^*/
	servo_data[0] = 1720;
	servo_data[1] = 1720;
	servo_data[2] = 1720;
	servo_data[3] = 1720;

	servo_data[4] = 1720;
	servo_data[5] = 1720;
	servo_data[6] = 1720;
	servo_data[7] = 1720;

	/********************************************************/
	while(1)
	{
		TW.TCNT = 0;
		/*ʐM֘ÃZNV*/
		do{
			command = sio_comm(servo_data, &servo_sw);
			timer = TW.TCNT;
		}while(timer < 40000 && command == 0);

		/*qbT[{Mo*/
		if(servo_sw == 1) generate_signal(servo_data);
	}
}
/********************************************************/
/*T[{M*/
void generate_signal(unsigned int servo_data[8])
{
unsigned char	i, bitptn0;
unsigned int	servo_work[2];

	/*3000JEgłPDT*/

	bitptn0 = 1;
	for(i = 0; i < 4; i++)
	{
		TW.TCNT = 0;
		IO.PDR8.BYTE = bitptn0;
		/*IO.PDR5.BYTE = bitptn0;*/
		if(i == 0) IO.PDR5.BIT.B0 =1;
		if(i == 1) IO.PDR5.BIT.B1 =1;
		if(i == 2) IO.PDR5.BIT.B2 =1;
		/************************************************/

		servo_work[0] = servo_data[i];
		servo_work[1] = servo_data[i + 4];
		wait_val(servo_work);

		IO.PDR8.BYTE = IO.PDR8.BYTE & 0xf0;
		/*IO.PDR5.BYTE = IO.PDR5.BYTE & 0xf0;*/
		IO.PDR5.BYTE = IO.PDR5.BYTE & 0xf8;

		bitptn0 = bitptn0 * 2;
	}
	return;
}
/*************************************************************/
/**  w肳ꂽԑ҂                                     **/
/*************************************************************/
void wait_val(unsigned int servo_data[2])
{
unsigned char	i;
unsigned int	data[2];

	for(i = 0; i < 2; i++)
	{
		data[i] = 4720 - servo_data[i];
	}

	do{
		if(TW.TCNT >= data[0]) IO.PDR8.BYTE = IO.PDR8.BYTE & 0xf0;
		/*if(TW.TCNT >= data[1]) IO.PDR5.BYTE = IO.PDR5.BYTE & 0xf0;*/
		if(TW.TCNT >= data[1]) IO.PDR5.BYTE = IO.PDR5.BYTE & 0xf8;
	}while (TW.TCNT < data[0] || TW.TCNT < data[1]);

	return;
}
/*********************************************************************/
unsigned char sio_comm(unsigned int servo_data[8], unsigned char *servo_sw)
{
unsigned char	i, command, touch_sw;
unsigned int	ii;

	/*ʐM֘ÃZNV*/
	command = read_c_sci3_b();
	/*obt@̂Ƃ͋A*/
	if(command == 0) return(0);
	print_c_sci3(command);/*MfB[*/

	/*LED ON/OFFp̂Pbito*/
	if(command == 'A')
	{
		IO.PDR5.BIT.B3 = read_c_sci3() & 1;
	}

	if(command == 'B')
	{
		/*qbT[{֐߃f[^M*/
		/*T[{O@@T[{V̏Ńf[^󂯎*/
		for(i = 0; i < 8; i++)
		{
			ii = read_ii_sci3b();
			servo_data[i] = ii;
		}
	}

	if(command == 'J')
	{
		/*^b`ZT񑗐M*/
		touch_sw = IO.PDR5.BIT.B5 * 128 + IO.PDR5.BIT.B4 * 64 + IO.PDR1.BIT.B2 * 32 + IO.PDR1.BIT.B1 * 16;
		print_c_sci3(touch_sw);
	}

	/*XCb`M(WCAT[{̂nm^nee)*/
	if(command == 'K')
	{
		*servo_sw	= read_c_sci3() & 1;
	}
	return(command);
}

/*********************************************************************/
void init_main(void)
{

	/*^b`ZTڑ|[g*/
	IO.PUCR1.BIT.B1 = 1;
	IO.PUCR1.BIT.B2 = 1;
	IO.PUCR5.BIT.B4 = 1;
	IO.PUCR5.BIT.B5 = 1;

	/*qbT[{ڑ|[g*/
	IO.PCR5 = 0x0f;
	IO.PCR8 = 0x0f;

	/*NbNWT*/
	TW.TCRW.BIT.CKS = 3;
	/*TW Startt[jO[h*/
	TW.TMRW.BIT.CTS = 1;

	/*A/DRo[^@WX^ݒ*/
	/*XL[h*/
	/*vXe[g134*/
	/*0`3cĥ݌JԂϊ*/
	/*ϊX^[g*/
	/*
	AD.CSR.BIT.SCAN = 1;
	AD.CSR.BIT.CKS = 0;
	AD.CSR.BIT.CH = 7;
	AD.CSR.BIT.ADST = 1;
	*/

	/*VAC^[tFCX*/
	SCI3.SCR3.BYTE	= 0x00;
	SCI3.SMR.BYTE	= 0x00;

	SCI3.BRR		= 12;/*38400 bps*/

	/*SCI3.BRR		= 25;*//*19200 bps*/
	/*SCI3.BRR		= 51; 9600 bps*/

	/*Wait*/
	TW.TCNT = 0;
	while(TW.TCNT < 1000);

	SCI3.SCR3.BIT.TE = 1;
	SCI3.SCR3.BIT.RE = 1;

	IO.PMR1.BIT.TXD = 1;
}

/*************************************************************/
/*̐^[~iʂɕ\(AsciiR[ho)*/
/*************************************************************/
void print_ii_sci3(unsigned int data)
{
unsigned int		i, j, bitptn;
unsigned char		string[16];

	bitptn = 10000;
	for(i = 0; i < 5; i++)
	{
		j = data / bitptn;
		string[i] = '0' + j;
		data = data - bitptn * j;
		bitptn = bitptn / 10;
	}

	for(i = 0; i < 4; i++)
	{
		if(string[i] == '0') string[i] = ' ';
		else break;
	}

	string[5] = 0x0d;
	string[6] = 0x0a;
	string[7] = 0x00;

	for(i = 0; i < 7; i++) print_c_sci3(string[i]);

	return;
}

/******************************************************/
/*unsigned int ϐ 2 oCgVA|[g֏o͂*/
/******************************************************/
void print_ii_sci3b(unsigned int data)
{
unsigned int	ii;
unsigned char	data_L, data_H;

	if(data > 255)
	{
		ii = data / 256;
		data_H = (unsigned char)ii;
	}
	else
	{
		ii = 0;
		data_H = 0;
	}

	ii = data - ii * 256;
	data_L = (unsigned char)ii;

	print_c_sci3(data_H);
	print_c_sci3(data_L);

	return;
}

/*charϐPoCgVA|[g֏o͂*/
void print_c_sci3(unsigned char	data)
{

	while(SCI3.SSR.BIT.TDRE == 0);
	SCI3.TDR = data;
	return;
}

/*charϐPoCgVA|[g͂*/
/*͂܂ő҂*/
unsigned char read_c_sci3(void)
{
unsigned char	data;

	while(SCI3.SSR.BIT.RDRF == 0);
	data = SCI3.RDR;
	return(data);
}

/*charϐPoCgVA|[g͂*/
/*͗vȂ΋A*/
unsigned char read_c_sci3_b(void)
{
unsigned char	data;

	if(SCI3.SSR.BIT.RDRF == 0) return(0);
	data = SCI3.RDR;
	return(data);
}

/*O`UTTRT̐VA|[g͂*/
unsigned int read_ii_sci3b(void)
{
unsigned int	data;
unsigned int	data_L, data_H;

	data_H = (unsigned int)read_c_sci3();
	data_L = (unsigned int)read_c_sci3();
	data = data_H * 256 + data_L;
	return(data);
}
